; ******************************************************
; *   2009 & 2010 By Hroudtwolf
; *   PureBasic 4.x
; ******************************************************

#GFX_INIT_2D         = 2
#GFX_INIT_3D         = 4
#GFX_INIT_MOUSE      = 8
#GFX_INIT_KEYBOARD   = 16

Procedure.i GFX_Init (blFlags.i = #GFX_INIT_2D)
   Protected blAnyInit.i = #False
   
   If (blFlags & #GFX_INIT_2D = #GFX_INIT_2D)
      If Not (InitSprite ())
         ProcedureReturn #False
      EndIf
      blAnyInit = #True
   EndIf
   
   If (blFlags & #GFX_INIT_3D = #GFX_INIT_3D)
      If Not (InitSprite3D ())
         ProcedureReturn #False
      EndIf
      blAnyInit = #True
   EndIf
   
   If (blFlags & #GFX_INIT_MOUSE = #GFX_INIT_MOUSE)
      If Not (InitMouse ())
         ProcedureReturn #False
      EndIf
      blAnyInit = #True      
   EndIf
   
   If (blFlags & #GFX_INIT_KEYBOARD = #GFX_INIT_KEYBOARD)
      If Not (InitKeyboard ())
         ProcedureReturn #False
      EndIf
      blAnyInit = #True
   EndIf
   
   If Not (blAnyInit)
      ProcedureReturn #False
   EndIf
   
   ProcedureReturn #True
EndProcedure

Procedure.i GFX_OpenWindow (nWidth.i, nHeight.i, sTitle.s)
   Protected.i idWindow
   
   idWindow = OpenWindow (#PB_Any, #PB_Ignore, #PB_Ignore,800, 600, "Intro", #PB_Window_ScreenCentered | #PB_Window_SystemMenu)
   If Not (idWindow)
      ProcedureReturn #False
   EndIf
   
   If Not (OpenWindowedScreen (WindowID (idWindow), 0, 0, 800, 600, #False, 0, 0, #PB_Screen_SmartSynchronization))
      ProcedureReturn #False
   EndIf

   ProcedureReturn #True
EndProcedure

Procedure.i GFX_WindowEventDispatcher ()
   Repeat
      Select (WindowEvent ())
         Case #PB_Event_CloseWindow
         End
         
         Case #Null
         Break
      EndSelect
   ForEver
   
   ProcedureReturn #Null
EndProcedure
; IDE Options = PureBasic 4.40 (Windows - x86)
; CursorPosition = 3
; Folding = -
; EnableXP
; CurrentDirectory = C:\Program Files (x86)\PureBasic\
; CompileSourceDirectory