; ******************************************************
; *   2009 & 2010 By Hroudtwolf
; *   PureBasic 4.x
; ******************************************************

Structure tScrollText
   nX.i
   nY.i
   *Sprite
EndStructure

Structure tTextSprite
   *Sprite2D
   *Sprite3D
EndStructure

Global NewList ScrollText.tScrollText ()
Global Dim     CharArray .tTextSprite  ($FF) 

Procedure.i ScrollText_Update () 
   Shared      nLastScrollTextX  .i
   
   ForEach (ScrollText ())
      ScrollText ()\nX - 2      
      ScrollText ()\nY = Sin (ScrollText ()\nX / 50) * 60
      
      If (ScrollText ()\nX < -68 )
         ScrollText ()\nX = nLastScrollTextX      
      EndIf
   Next

   ProcedureReturn #Null
EndProcedure

Procedure.i ScrollText_Display (nX.i, nY.i) 
   Static      nNextTick         .i

   If Not (ListSize (ScrollText ()))
      ProcedureReturn #False
   EndIf
   
   ForEach (ScrollText ())
      If (ScrollText ()\nX < #SCREEN_CX And ScrollText ()\Sprite) 
         TransformSprite3D (ScrollText ()\Sprite, ScrollText ()\nY / 10, 0,  48 + (ScrollText ()\nY / 10) , 0, 48  - (ScrollText ()\nY / 10), 48, - (ScrollText ()\nY / 10), 48)   
         DisplaySprite3D  (ScrollText ()\Sprite, nX + ScrollText ()\nX,  nY + ScrollText ()\nY)
      EndIf
   Next 
   
   ProcedureReturn #True
EndProcedure

Procedure.i ScrollText_GetChar (cChar.c)   
   Static idFont.i
   
   If Not (idFont)
      idFont = LoadFont (#PB_Any, "Fixedsys", 30, #PB_Font_Bold)
   EndIf
   
  
   If Not (CharArray (cChar)\Sprite3D)
      CharArray (cChar)\Sprite2D = CreateSprite (#PB_Any, 48, 48, #PB_Sprite_Texture)
      If (StartDrawing (SpriteOutput (CharArray (cChar)\Sprite2D)))
         DrawingFont (FontID (idFont))
         DrawingMode (#PB_2DDrawing_Transparent)    
         DrawText (0, 0, Chr (cChar), $0C3A7C) 
         DrawText (0, 4, Chr (cChar), $0C3A7C) 
         DrawText (4, 0, Chr (cChar), $0C3A7C) 
         DrawText (4, 4, Chr (cChar), $0C3A7C)          
         DrawText (1, 1, Chr (cChar), $00FFFF) 
         DrawText (1, 3, Chr (cChar), $00FFFF) 
         DrawText (3, 1, Chr (cChar), $003131) 
         DrawText (3, 3, Chr (cChar), $003131)        
         DrawText (2, 2, Chr (cChar), $00DDDD) 
         StopDrawing ()
      EndIf

      CharArray (cChar)\Sprite3D = CreateSprite3D (#PB_Any, CharArray (cChar)\Sprite2D)
   EndIf
 
   ProcedureReturn CharArray (cChar)\Sprite3D
EndProcedure
 
Procedure.i ScrollText_Add (sText.s)
   Protected   *Source           .CHARACTER = @ sText
   Static      nX                .i
   Shared      nLastScrollTextX  .i
       
   While (*Source\c)
      AddElement (ScrollText ())
      ScrollText ()\nX     = #SCREEN_CX + nX
      ScrollText ()\nY     = 0
      
      If (*Source\c = 32)
         ScrollText ()\Sprite= #Null
      Else
         ScrollText ()\Sprite = ScrollText_GetChar (*Source\c)
      EndIf
      
      nX               + 24
      nLastScrollTextX = nX 
      *Source  + SizeOf (CHARACTER)
   Wend   
   
   ProcedureReturn #Null
EndProcedure
; IDE Options = PureBasic 4.40 (Windows - x86)
; CursorPosition = 72
; FirstLine = 57
; Folding = -
; EnableXP
; UseMainFile = main.pb
; CurrentDirectory = C:\Program Files (x86)\PureBasic\
; CompileSourceDirectory