; ******************************************************
; *   2009 & 2010 By Hroudtwolf
; *   PureBasic 4.x
; ******************************************************

Structure tStar
   nSize .i
   nX    .i
   nY    .i
   nSpeed.i
EndStructure

Structure tStarScroller
   star        .tStar [$FF]
   idSprite2D  .i
   idSprite3D  .i
EndStructure 

Procedure.i GetModule_StarScroller ()
   Static this.tStarScroller
   
   ProcedureReturn this
EndProcedure 

Procedure.i StarScroller_Init ()
   Protected *this      .tStarScroller = GetModule_StarScroller ()
   Protected idTempImage.i
   Protected nI         .i             = 0
   
   idTempImage = CreateImage (#PB_Any, 128, 128)
   
   StartDrawing      (ImageOutput (idTempImage))   
   DrawingMode       (#PB_2DDrawing_Gradient)      
   BackColor         (0)
   FrontColor        ($00FFDD)  
   GradientColor     (0, $00FFDD)
   GradientColor     (1, $FFFFFF)          
   CircularGradient  (64, 64, 64)
   Circle            (64, 64, 64)  
   StopDrawing       () 
   
   *this\idSprite2D  = CreateSprite (#PB_Any, 128, 128, #PB_Sprite_Texture)
   
   StartDrawing   (SpriteOutput (*this\idSprite2D))  
   DrawImage      (ImageID (idTempImage), 0, 0, 128, 128)
   StopDrawing    () 
   
   *this\idSprite3D = CreateSprite3D (#PB_Any, *this\idSprite2D)
   
   FreeImage      (idTempImage)
   
   While (nI < $FF)
      *this\star [nI]\nX      = Random (#SCREEN_CX)
      *this\star [nI]\nY      = Random (#SCREEN_CY)
      *this\star [nI]\nSize   = Random (2) + 2
      *this\star [nI]\nSpeed  = Random (2) + 1
      nI + 1
   Wend
   
   ProcedureReturn #Null
EndProcedure

Procedure.i StarScroller_Update ()
   Protected *this      .tStarScroller = GetModule_StarScroller ()
   Protected nI         .i             = 0
   
   While (nI < $FF)
      *this\star [nI]\nX - *this\star [nI]\nSpeed
      If (*this\star [nI]\nX < -*this\star [nI]\nSize)
         *this\star [nI]\nX      = #SCREEN_CX
         *this\star [nI]\nY      = Random (#SCREEN_CY)
         *this\star [nI]\nSize   = Random (2) + 2
         *this\star [nI]\nSpeed  = Random (2) + 1
      EndIf
      nI + 1
   Wend
   
   ProcedureReturn #Null
EndProcedure

Procedure.i StarScroller_Display ()
   Protected *this      .tStarScroller = GetModule_StarScroller ()
   Protected nI         .i             = 0
   
   While (nI < $FF)
      ZoomSprite3D      (*this\idSprite3D, *this\star [nI]\nSize, *this\star [nI]\nSize)
      DisplaySprite3D   (*this\idSprite3D, *this\star [nI]\nX, *this\star [nI]\nY, 255 - (50 * *this\star [nI]\nSize))
      nI + 1
   Wend
   
   ProcedureReturn #Null
EndProcedure
; IDE Options = PureBasic 4.40 (Windows - x86)
; CursorPosition = 3
; Folding = -
; EnableXP
; UseMainFile = main.pb
; CurrentDirectory = C:\Program Files (x86)\PureBasic\
; CompileSourceDirectory